Index: uspace/srv/hid/display/cfgops.c
===================================================================
--- uspace/srv/hid/display/cfgops.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/srv/hid/display/cfgops.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,373 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup display
+ * @{
+ */
+/**
+ * @file Display configuration ops implementation
+ */
+
+#include <errno.h>
+#include <io/log.h>
+#include <stdlib.h>
+#include <str.h>
+#include <dispcfg_srv.h>
+#include "display.h"
+#include "idevcfg.h"
+#include "seat.h"
+#include "cfgclient.h"
+
+static errno_t dispc_get_seat_list(void *, dispcfg_seat_list_t **);
+static errno_t dispc_get_seat_info(void *, sysarg_t, dispcfg_seat_info_t **);
+static errno_t dispc_seat_create(void *, const char *, sysarg_t *);
+static errno_t dispc_seat_delete(void *, sysarg_t);
+static errno_t dispc_dev_assign(void *, sysarg_t, sysarg_t);
+static errno_t dispc_dev_unassign(void *, sysarg_t);
+static errno_t dispc_get_asgn_dev_list(void *, sysarg_t, dispcfg_dev_list_t **);
+static errno_t dispc_get_event(void *, dispcfg_ev_t *);
+
+dispcfg_ops_t dispcfg_srv_ops = {
+	.get_seat_list = dispc_get_seat_list,
+	.get_seat_info = dispc_get_seat_info,
+	.seat_create = dispc_seat_create,
+	.seat_delete = dispc_seat_delete,
+	.dev_assign = dispc_dev_assign,
+	.dev_unassign = dispc_dev_unassign,
+	.get_asgn_dev_list = dispc_get_asgn_dev_list,
+	.get_event = dispc_get_event,
+};
+
+/** Get seat list.
+ *
+ * @param arg Argument (CFG client)
+ * @param rlist Place to store pointer to new list
+ * @return EOK on success or an error code
+ */
+static errno_t dispc_get_seat_list(void *arg, dispcfg_seat_list_t **rlist)
+{
+	ds_cfgclient_t *cfgclient = (ds_cfgclient_t *)arg;
+	dispcfg_seat_list_t *list;
+	ds_seat_t *seat;
+	unsigned i;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "dispcfg_get_seat_list()");
+
+	list = calloc(1, sizeof(dispcfg_seat_list_t));
+	if (list == NULL)
+		return ENOMEM;
+
+	ds_display_lock(cfgclient->display);
+
+	/* Count the number of seats */
+	list->nseats = 0;
+	seat = ds_display_first_seat(cfgclient->display);
+	while (seat != NULL) {
+		++list->nseats;
+		seat = ds_display_next_seat(seat);
+	}
+
+	/* Allocate array for seat IDs */
+	list->seats = calloc(list->nseats, sizeof(sysarg_t));
+	if (list->seats == NULL) {
+		ds_display_unlock(cfgclient->display);
+		free(list);
+		return ENOMEM;
+	}
+
+	/* Fill in seat IDs */
+	i = 0;
+	seat = ds_display_first_seat(cfgclient->display);
+	while (seat != NULL) {
+		list->seats[i++] = seat->id;
+		seat = ds_display_next_seat(seat);
+	}
+
+	ds_display_unlock(cfgclient->display);
+	*rlist = list;
+	return EOK;
+}
+
+/** Get seat information.
+ *
+ * @param arg Argument (CFG client)
+ * @param seat_id Seat ID
+ * @param rinfo Place to store pointer to new seat information structure
+ * @return EOK on success or an error code
+ */
+static errno_t dispc_get_seat_info(void *arg, sysarg_t seat_id,
+    dispcfg_seat_info_t **rinfo)
+{
+	ds_cfgclient_t *cfgclient = (ds_cfgclient_t *)arg;
+	ds_seat_t *seat;
+	dispcfg_seat_info_t *info;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "dispcfg_get_seat_info()");
+
+	ds_display_lock(cfgclient->display);
+	seat = ds_display_find_seat(cfgclient->display, seat_id);
+	if (seat == NULL) {
+		ds_display_unlock(cfgclient->display);
+		return ENOENT;
+	}
+
+	info = calloc(1, sizeof(dispcfg_seat_info_t));
+	if (info == NULL) {
+		ds_display_unlock(cfgclient->display);
+		return ENOMEM;
+	}
+
+	(void)seat;
+	info->name = str_dup(seat->name);
+	if (info->name == NULL) {
+		ds_display_unlock(cfgclient->display);
+		free(info);
+		return ENOMEM;
+	}
+
+	ds_display_unlock(cfgclient->display);
+	*rinfo = info;
+	return EOK;
+}
+
+/** Create seat.
+ *
+ * @param arg Argument (CFG client)
+ * @param name Seat name
+ * @param rseat_id Place to store ID of the new seat
+ * @return EOK on success or an error code
+ */
+static errno_t dispc_seat_create(void *arg, const char *name,
+    sysarg_t *rseat_id)
+{
+	ds_cfgclient_t *cfgclient = (ds_cfgclient_t *)arg;
+	ds_seat_t *seat;
+	errno_t rc;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "dispcfg_seat_create()");
+
+	ds_display_lock(cfgclient->display);
+
+	rc = ds_seat_create(cfgclient->display, name, &seat);
+	if (rc != EOK) {
+		ds_display_unlock(cfgclient->display);
+		return rc;
+	}
+
+	(void) ds_display_paint(cfgclient->display, NULL);
+	ds_display_unlock(cfgclient->display);
+
+	*rseat_id = seat->id;
+	return EOK;
+}
+
+/** Delete seat.
+ *
+ * @param arg Argument (CFG client)
+ * @param seat_id Seat ID
+ * @return EOK on success or an error code
+ */
+static errno_t dispc_seat_delete(void *arg, sysarg_t seat_id)
+{
+	ds_cfgclient_t *cfgclient = (ds_cfgclient_t *)arg;
+	ds_seat_t *seat;
+	ds_seat_t *s;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "dispcfg_seat_delete()");
+
+	ds_display_lock(cfgclient->display);
+	seat = ds_display_find_seat(cfgclient->display, seat_id);
+	if (seat == NULL) {
+		ds_display_unlock(cfgclient->display);
+		return ENOENT;
+	}
+
+	/* Verify we are not deleting the last seat */
+	s = ds_display_first_seat(cfgclient->display);
+	if (s == seat && ds_display_next_seat(s) == NULL) {
+		ds_display_unlock(cfgclient->display);
+		return EBUSY;
+	}
+
+	ds_seat_destroy(seat);
+
+	(void) ds_display_paint(cfgclient->display, NULL);
+	ds_display_unlock(cfgclient->display);
+	return EOK;
+}
+
+/** Assign device to seat.
+ *
+ * @param arg Argument (CFG client)
+ * @param svc_id Device service ID
+ * @param seat_id Seat ID
+ * @return EOK on success or an error code
+ */
+static errno_t dispc_dev_assign(void *arg, sysarg_t svc_id, sysarg_t seat_id)
+{
+	ds_cfgclient_t *cfgclient = (ds_cfgclient_t *)arg;
+	ds_seat_t *seat;
+	ds_idevcfg_t *idevcfg;
+	errno_t rc;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "dispcfg_dev_assign()");
+
+	ds_display_lock(cfgclient->display);
+	seat = ds_display_find_seat(cfgclient->display, seat_id);
+	if (seat == NULL) {
+		ds_display_unlock(cfgclient->display);
+		return ENOENT;
+	}
+
+	rc = ds_idevcfg_create(cfgclient->display, svc_id, seat, &idevcfg);
+	if (rc != EOK) {
+		assert(rc == ENOMEM);
+		ds_display_unlock(cfgclient->display);
+		return ENOMEM;
+	}
+
+	(void)idevcfg;
+
+	ds_display_unlock(cfgclient->display);
+	return EOK;
+}
+
+/** Unassign device from any seat.
+ *
+ * @param arg Argument (CFG client)
+ * @param svc_id Device service ID
+ * @return EOK on success or an error code
+ */
+static errno_t dispc_dev_unassign(void *arg, sysarg_t svc_id)
+{
+	ds_cfgclient_t *cfgclient = (ds_cfgclient_t *)arg;
+	ds_idevcfg_t *idevcfg;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "dispcfg_dev_unassign()");
+
+	ds_display_lock(cfgclient->display);
+
+	idevcfg = ds_display_first_idevcfg(cfgclient->display);
+	while (idevcfg != NULL) {
+		if (idevcfg->svc_id == svc_id)
+			break;
+
+		idevcfg = ds_display_next_idevcfg(idevcfg);
+	}
+
+	if (idevcfg == NULL) {
+		ds_display_unlock(cfgclient->display);
+		return ENOENT;
+	}
+
+	ds_idevcfg_destroy(idevcfg);
+	ds_display_unlock(cfgclient->display);
+	return EOK;
+}
+
+/** Get assigned device list.
+ *
+ * @param arg Argument (CFG client)
+ * @param seat_id Seat ID
+ * @param rlist Place to store pointer to new list
+ * @return EOK on success or an error code
+ */
+static errno_t dispc_get_asgn_dev_list(void *arg, sysarg_t seat_id,
+    dispcfg_dev_list_t **rlist)
+{
+	ds_cfgclient_t *cfgclient = (ds_cfgclient_t *)arg;
+	dispcfg_dev_list_t *list;
+	ds_seat_t *seat;
+	ds_idevcfg_t *idevcfg;
+	unsigned i;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "dispcfg_get_asgn_dev_list()");
+
+	list = calloc(1, sizeof(dispcfg_dev_list_t));
+	if (list == NULL)
+		return ENOMEM;
+
+	ds_display_lock(cfgclient->display);
+
+	seat = ds_display_find_seat(cfgclient->display, seat_id);
+	if (seat == NULL) {
+		ds_display_unlock(cfgclient->display);
+		free(list);
+		return ENOENT;
+	}
+
+	/* Count the number of devices */
+	list->ndevs = 0;
+	idevcfg = ds_seat_first_idevcfg(seat);
+	while (idevcfg != NULL) {
+		++list->ndevs;
+		idevcfg = ds_display_next_idevcfg(idevcfg);
+	}
+
+	/* Allocate array for device IDs */
+	list->devs = calloc(list->ndevs, sizeof(sysarg_t));
+	if (list->devs == NULL) {
+		ds_display_unlock(cfgclient->display);
+		free(list);
+		return ENOMEM;
+	}
+
+	/* Fill in device IDs */
+	i = 0;
+	idevcfg = ds_seat_first_idevcfg(seat);
+	while (idevcfg != NULL) {
+		list->devs[i++] = idevcfg->svc_id;
+		idevcfg = ds_display_next_idevcfg(idevcfg);
+	}
+
+	ds_display_unlock(cfgclient->display);
+	*rlist = list;
+	return EOK;
+}
+
+/** Get display configuration event.
+ *
+ * @param arg Argument (CFG client)
+ * @param ev Place to store event
+ * @return EOK on success, ENOENT if there are no events
+ */
+static errno_t dispc_get_event(void *arg, dispcfg_ev_t *ev)
+{
+	ds_cfgclient_t *cfgclient = (ds_cfgclient_t *)arg;
+	errno_t rc;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "dispcfg_get_event()");
+
+	ds_display_lock(cfgclient->display);
+	rc = ds_cfgclient_get_event(cfgclient, ev);
+	ds_display_unlock(cfgclient->display);
+	return rc;
+}
+
+/** @}
+ */
Index: uspace/srv/hid/display/cfgops.h
===================================================================
--- uspace/srv/hid/display/cfgops.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/srv/hid/display/cfgops.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,46 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup display
+ * @{
+ */
+/**
+ * @file Display configuration ops implementation
+ */
+
+#ifndef CFGOPS_H
+#define CFGOPS_H
+
+#include <dispcfg_srv.h>
+
+extern dispcfg_ops_t dispcfg_srv_ops;
+
+#endif
+
+/** @}
+ */
Index: uspace/srv/hid/display/client.c
===================================================================
--- uspace/srv/hid/display/client.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/display/client.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -181,5 +181,5 @@
  * @param ewindow Place to store pointer to window receiving the event
  * @param event Place to store event
- * @return Graphic context
+ * @return EOK on success, ENOENT if event queue is empty
  */
 errno_t ds_client_get_event(ds_client_t *client, ds_window_t **ewindow,
@@ -257,8 +257,10 @@
  * @param client Client
  * @param ewindow Window that the message is targetted to
- *
- * @return EOK on success or an error code
- */
-errno_t ds_client_post_focus_event(ds_client_t *client, ds_window_t *ewindow)
+ * @param event Focus event data
+ *
+ * @return EOK on success or an error code
+ */
+errno_t ds_client_post_focus_event(ds_client_t *client, ds_window_t *ewindow,
+    display_wnd_focus_ev_t *event)
 {
 	ds_window_ev_t *wevent;
@@ -270,4 +272,5 @@
 	wevent->window = ewindow;
 	wevent->event.etype = wev_focus;
+	wevent->event.ev.focus = *event;
 	list_append(&wevent->levents, &client->events);
 
@@ -373,8 +376,10 @@
  * @param client Client
  * @param ewindow Window that the message is targetted to
- *
- * @return EOK on success or an error code
- */
-errno_t ds_client_post_unfocus_event(ds_client_t *client, ds_window_t *ewindow)
+ * @param event Unfocus event data
+ *
+ * @return EOK on success or an error code
+ */
+errno_t ds_client_post_unfocus_event(ds_client_t *client, ds_window_t *ewindow,
+    display_wnd_unfocus_ev_t *event)
 {
 	ds_window_ev_t *wevent;
@@ -386,4 +391,5 @@
 	wevent->window = ewindow;
 	wevent->event.etype = wev_unfocus;
+	wevent->event.ev.unfocus = *event;
 	list_append(&wevent->levents, &client->events);
 
Index: uspace/srv/hid/display/client.h
===================================================================
--- uspace/srv/hid/display/client.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/display/client.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -55,5 +55,6 @@
 extern void ds_client_purge_window_events(ds_client_t *, ds_window_t *);
 extern errno_t ds_client_post_close_event(ds_client_t *, ds_window_t *);
-extern errno_t ds_client_post_focus_event(ds_client_t *, ds_window_t *);
+extern errno_t ds_client_post_focus_event(ds_client_t *, ds_window_t *,
+    display_wnd_focus_ev_t *);
 extern errno_t ds_client_post_kbd_event(ds_client_t *, ds_window_t *,
     kbd_event_t *);
@@ -62,5 +63,6 @@
 extern errno_t ds_client_post_resize_event(ds_client_t *, ds_window_t *,
     gfx_rect_t *);
-extern errno_t ds_client_post_unfocus_event(ds_client_t *, ds_window_t *);
+extern errno_t ds_client_post_unfocus_event(ds_client_t *, ds_window_t *,
+    display_wnd_unfocus_ev_t *);
 
 #endif
Index: uspace/srv/hid/display/display.c
===================================================================
--- uspace/srv/hid/display/display.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/display/display.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -45,7 +45,8 @@
 #include "cursimg.h"
 #include "cursor.h"
+#include "display.h"
 #include "seat.h"
 #include "window.h"
-#include "display.h"
+#include "wmclient.h"
 
 static gfx_context_t *ds_display_get_unbuf_gc(ds_display_t *);
@@ -96,6 +97,9 @@
 	fibril_mutex_initialize(&disp->lock);
 	list_initialize(&disp->clients);
+	list_initialize(&disp->wmclients);
+	list_initialize(&disp->cfgclients);
 	disp->next_wnd_id = 1;
 	list_initialize(&disp->ddevs);
+	list_initialize(&disp->idevcfgs);
 	list_initialize(&disp->seats);
 	list_initialize(&disp->windows);
@@ -114,7 +118,21 @@
 void ds_display_destroy(ds_display_t *disp)
 {
+	int i;
+
 	assert(list_empty(&disp->clients));
+	assert(list_empty(&disp->wmclients));
+	assert(list_empty(&disp->cfgclients));
 	assert(list_empty(&disp->seats));
-	/* XXX destroy cursors */
+	assert(list_empty(&disp->ddevs));
+	assert(list_empty(&disp->idevcfgs));
+	assert(list_empty(&disp->seats));
+	assert(list_empty(&disp->windows));
+
+	/* Destroy cursors */
+	for (i = 0; i < dcurs_limit; i++) {
+		ds_cursor_destroy(disp->cursor[i]);
+		disp->cursor[i] = NULL;
+	}
+
 	gfx_color_delete(disp->bg_color);
 	free(disp);
@@ -203,4 +221,83 @@
 
 	return list_get_instance(link, ds_client_t, lclients);
+}
+
+/** Add WM client to display.
+ *
+ * @param disp Display
+ * @param wmclient WM client
+ */
+void ds_display_add_wmclient(ds_display_t *disp, ds_wmclient_t *wmclient)
+{
+	assert(wmclient->display == NULL);
+	assert(!link_used(&wmclient->lwmclients));
+
+	wmclient->display = disp;
+	list_append(&wmclient->lwmclients, &disp->wmclients);
+}
+
+/** Remove WM client from display.
+ *
+ * @param wmclient WM client
+ */
+void ds_display_remove_wmclient(ds_wmclient_t *wmclient)
+{
+	list_remove(&wmclient->lwmclients);
+	wmclient->display = NULL;
+}
+
+/** Add CFG client to display.
+ *
+ * @param disp Display
+ * @param cfgclient CFG client
+ */
+void ds_display_add_cfgclient(ds_display_t *disp, ds_cfgclient_t *cfgclient)
+{
+	assert(cfgclient->display == NULL);
+	assert(!link_used(&cfgclient->lcfgclients));
+
+	cfgclient->display = disp;
+	list_append(&cfgclient->lcfgclients, &disp->cfgclients);
+}
+
+/** Remove CFG client from display.
+ *
+ * @param cfgclient CFG client
+ */
+void ds_display_remove_cfgclient(ds_cfgclient_t *cfgclient)
+{
+	list_remove(&cfgclient->lcfgclients);
+	cfgclient->display = NULL;
+}
+
+/** Get first WM client in display.
+ *
+ * @param disp Display
+ * @return First WM client or @c NULL if there is none
+ */
+ds_wmclient_t *ds_display_first_wmclient(ds_display_t *disp)
+{
+	link_t *link = list_first(&disp->wmclients);
+
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, ds_wmclient_t, lwmclients);
+}
+
+/** Get next WM client in display.
+ *
+ * @param wmclient Current WM client
+ * @return Next WM client or @c NULL if there is none
+ */
+ds_wmclient_t *ds_display_next_wmclient(ds_wmclient_t *wmclient)
+{
+	link_t *link = list_next(&wmclient->lwmclients,
+	    &wmclient->display->wmclients);
+
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, ds_wmclient_t, lwmclients);
 }
 
@@ -246,5 +343,6 @@
 		gfx_rect_translate(&wnd->dpos, &wnd->rect, &drect);
 
-		if (gfx_pix_inside_rect(pos, &drect))
+		if (gfx_pix_inside_rect(pos, &drect) &&
+		    ds_window_is_visible(wnd))
 			return wnd;
 
@@ -255,4 +353,36 @@
 }
 
+/** Add window to window list.
+ *
+ * Topmost windows are enlisted before any other window. Non-topmost
+ * windows are enlisted before any other non-topmost window.
+ *
+ * @param display Display
+ * @param wnd Window
+ */
+void ds_display_enlist_window(ds_display_t *display, ds_window_t *wnd)
+{
+	ds_window_t *w;
+
+	assert(wnd->display == display);
+	assert(!link_used(&wnd->ldwindows));
+
+	if ((wnd->flags & wndf_topmost) == 0) {
+		/* Find the first non-topmost window */
+		w = ds_display_first_window(display);
+		while (w != NULL && (w->flags & wndf_topmost) != 0)
+			w = ds_display_next_window(w);
+
+		if (w != NULL)
+			list_insert_before(&wnd->ldwindows, &w->ldwindows);
+		else
+			list_append(&wnd->ldwindows, &display->windows);
+	} else {
+		/* Insert at the beginning */
+		list_prepend(&wnd->ldwindows, &display->windows);
+	}
+
+}
+
 /** Add window to display.
  *
@@ -262,9 +392,18 @@
 void ds_display_add_window(ds_display_t *display, ds_window_t *wnd)
 {
+	ds_wmclient_t *wmclient;
+
 	assert(wnd->display == NULL);
 	assert(!link_used(&wnd->ldwindows));
 
 	wnd->display = display;
-	list_prepend(&wnd->ldwindows, &display->windows);
+	ds_display_enlist_window(display, wnd);
+
+	/* Notify window managers about the new window */
+	wmclient = ds_display_first_wmclient(display);
+	while (wmclient != NULL) {
+		ds_wmclient_post_wnd_added_event(wmclient, wnd->id);
+		wmclient = ds_display_next_wmclient(wmclient);
+	}
 }
 
@@ -275,6 +414,32 @@
 void ds_display_remove_window(ds_window_t *wnd)
 {
+	ds_wmclient_t *wmclient;
+	ds_display_t *display;
+
+	display = wnd->display;
+
 	list_remove(&wnd->ldwindows);
 	wnd->display = NULL;
+
+	/* Notify window managers about the removed window */
+	wmclient = ds_display_first_wmclient(display);
+	while (wmclient != NULL) {
+		ds_wmclient_post_wnd_removed_event(wmclient, wnd->id);
+		wmclient = ds_display_next_wmclient(wmclient);
+	}
+}
+
+/** Move window to top.
+ *
+ * @param display Display
+ * @param wnd Window
+ */
+void ds_display_window_to_top(ds_window_t *wnd)
+{
+	assert(wnd->display != NULL);
+	assert(link_used(&wnd->ldwindows));
+
+	list_remove(&wnd->ldwindows);
+	ds_display_enlist_window(wnd->display, wnd);
 }
 
@@ -352,6 +517,6 @@
 	ds_seat_t *seat;
 
-	// TODO Determine which seat the event belongs to
-	seat = ds_display_first_seat(display);
+	/* Determine which seat the event belongs to */
+	seat = ds_display_seat_by_idev(display, event->kbd_id);
 	if (seat == NULL)
 		return EOK;
@@ -369,6 +534,6 @@
 	ds_seat_t *seat;
 
-	// TODO Determine which seat the event belongs to
-	seat = ds_display_first_seat(display);
+	/* Determine which seat the event belongs to */
+	seat = ds_display_seat_by_idev(display, event->pos_id);
 	if (seat == NULL)
 		return EOK;
@@ -388,4 +553,5 @@
 
 	seat->display = disp;
+	seat->id = disp->next_seat_id++;
 	list_append(&seat->lseats, &disp->seats);
 }
@@ -429,4 +595,61 @@
 
 	return list_get_instance(link, ds_seat_t, lseats);
+}
+
+/** Get default seat in display.
+ *
+ * @param disp Display
+ * @return First seat or @c NULL if there is none
+ */
+ds_seat_t *ds_display_default_seat(ds_display_t *disp)
+{
+	/* XXX Probably not the best solution */
+	return ds_display_first_seat(disp);
+}
+
+/** Find seat by ID.
+ *
+ * @param display Display
+ * @param id Seat ID
+ */
+ds_seat_t *ds_display_find_seat(ds_display_t *display, ds_seat_id_t id)
+{
+	ds_seat_t *seat;
+
+	seat = ds_display_first_seat(display);
+	while (seat != NULL) {
+		if (seat->id == id)
+			return seat;
+
+		seat = ds_display_next_seat(seat);
+	}
+
+	return NULL;
+}
+
+/** Get seat which owns the specified input device.
+ *
+ * @param disp Display
+ * @param idev_id Input device ID
+ * @return Seat which owns device with ID @a idev_id or @c NULL if not found
+ */
+ds_seat_t *ds_display_seat_by_idev(ds_display_t *disp, ds_idev_id_t idev_id)
+{
+	ds_idevcfg_t *idevcfg;
+
+	/*
+	 * Find input device configuration entry that maps this input device
+	 * to a seat.
+	 */
+	idevcfg = ds_display_first_idevcfg(disp);
+	while (idevcfg != NULL) {
+		if (idevcfg->svc_id == idev_id)
+			return idevcfg->seat;
+
+		idevcfg = ds_display_next_idevcfg(idevcfg);
+	}
+
+	/* If none was found, return the default seat */
+	return ds_display_default_seat(disp);
 }
 
@@ -493,7 +716,10 @@
 {
 	errno_t rc;
+	gfx_rect_t old_disp_rect;
 
 	assert(ddev->display == NULL);
 	assert(!link_used(&ddev->lddevs));
+
+	old_disp_rect = disp->rect;
 
 	ddev->display = disp;
@@ -507,14 +733,12 @@
 		/* Create cloning GC */
 		rc = ds_clonegc_create(ddev->gc, &disp->fbgc);
-		if (rc != EOK) {
-			// XXX Remove output
-			return ENOMEM;
-		}
+		if (rc != EOK)
+			goto error;
 
 		/* Allocate backbuffer */
 		rc = ds_display_alloc_backbuf(disp);
 		if (rc != EOK) {
-			// XXX Remove output
-			// XXX Delete clone GC
+			ds_clonegc_delete(disp->fbgc);
+			disp->fbgc = NULL;
 			goto error;
 		}
@@ -526,10 +750,9 @@
 	}
 
+	ds_display_update_max_rect(disp);
+
 	return EOK;
 error:
-	disp->rect.p0.x = 0;
-	disp->rect.p0.y = 0;
-	disp->rect.p1.x = 0;
-	disp->rect.p1.y = 0;
+	disp->rect = old_disp_rect;
 	list_remove(&ddev->lddevs);
 	return rc;
@@ -576,4 +799,58 @@
 }
 
+/** Add input device configuration entry to display.
+ *
+ * @param disp Display
+ * @param idevcfg Input device configuration
+ */
+void ds_display_add_idevcfg(ds_display_t *disp, ds_idevcfg_t *idevcfg)
+{
+	assert(idevcfg->display == NULL);
+	assert(!link_used(&idevcfg->ldispidcfgs));
+
+	idevcfg->display = disp;
+	list_append(&idevcfg->ldispidcfgs, &disp->idevcfgs);
+}
+
+/** Remove input device configuration entry from display.
+ *
+ * @param idevcfg Input device configuration entry
+ */
+void ds_display_remove_idevcfg(ds_idevcfg_t *idevcfg)
+{
+	list_remove(&idevcfg->ldispidcfgs);
+	idevcfg->display = NULL;
+}
+
+/** Get first input device configuration entry in display.
+ *
+ * @param disp Display
+ * @return First input device configuration entry or @c NULL if there is none
+ */
+ds_idevcfg_t *ds_display_first_idevcfg(ds_display_t *disp)
+{
+	link_t *link = list_first(&disp->idevcfgs);
+
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, ds_idevcfg_t, ldispidcfgs);
+}
+
+/** Get next input device configuration entry in display.
+ *
+ * @param idevcfg Current input device configuration entry
+ * @return Next input device configuration entry or @c NULL if there is none
+ */
+ds_idevcfg_t *ds_display_next_idevcfg(ds_idevcfg_t *idevcfg)
+{
+	link_t *link = list_next(&idevcfg->ldispidcfgs, &idevcfg->display->idevcfgs);
+
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, ds_idevcfg_t, ldispidcfgs);
+}
+
 /** Add cursor to display.
  *
@@ -598,4 +875,69 @@
 	list_remove(&cursor->ldisplay);
 	cursor->display = NULL;
+}
+
+/** Update display maximize rectangle.
+ *
+ * Recalculate the maximize rectangle (the rectangle used for maximized
+ * windows).
+ *
+ * @param display Display
+ */
+void ds_display_update_max_rect(ds_display_t *display)
+{
+	ds_window_t *wnd;
+	gfx_rect_t max_rect;
+	gfx_rect_t drect;
+
+	/* Start with the entire display */
+	max_rect = display->rect;
+
+	wnd = ds_display_first_window(display);
+	while (wnd != NULL) {
+		/* Should maximized windows avoid this window? */
+		if ((wnd->flags & wndf_avoid) != 0) {
+			/* Window bounding rectangle on display */
+			gfx_rect_translate(&wnd->dpos, &wnd->rect, &drect);
+
+			/* Crop maximized rectangle */
+			ds_display_crop_max_rect(&drect, &max_rect);
+		}
+
+		wnd = ds_display_next_window(wnd);
+	}
+
+	/* Update the maximize rectangle */
+	display->max_rect = max_rect;
+}
+
+/** Crop maximize rectangle.
+ *
+ * Use the avoid rectangle @a arect to crop off maximization rectangle
+ * @a mrect. If @a arect covers the top, bottom, left or right part
+ * of @a mrect, it will be cropped off. Otherwise there will be
+ * no effect.
+ *
+ * @param arect Avoid rectangle
+ * @param mrect Maximize rectangle to be modified
+ */
+void ds_display_crop_max_rect(gfx_rect_t *arect, gfx_rect_t *mrect)
+{
+	if (arect->p0.x == mrect->p0.x && arect->p0.y == mrect->p0.y &&
+	    arect->p1.x == mrect->p1.x) {
+		/* Cropp off top part */
+		mrect->p0.y = arect->p1.y;
+	} else if (arect->p0.x == mrect->p0.x && arect->p1.x == mrect->p1.x &&
+	    arect->p1.y == mrect->p1.y) {
+		/* Cropp off bottom part */
+		mrect->p1.y = arect->p0.y;
+	} else if (arect->p0.x == mrect->p0.x && arect->p0.y == mrect->p0.y &&
+	    arect->p1.y == mrect->p1.y) {
+		/* Cropp off left part */
+		mrect->p0.x = arect->p1.x;
+	} else if (arect->p0.y == mrect->p0.y && arect->p1.x == mrect->p1.x &&
+	    arect->p1.y == mrect->p1.y) {
+		/* Cropp off right part */
+		mrect->p1.x = arect->p0.x;
+	}
 }
 
Index: uspace/srv/hid/display/display.h
===================================================================
--- uspace/srv/hid/display/display.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/display/display.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -42,10 +42,14 @@
 #include <gfx/coord.h>
 #include <io/kbd_event.h>
+#include "types/display/cfgclient.h"
 #include "types/display/client.h"
 #include "types/display/cursor.h"
 #include "types/display/ddev.h"
 #include "types/display/display.h"
+#include "types/display/idev.h"
+#include "types/display/idevcfg.h"
 #include "types/display/ptd_event.h"
 #include "types/display/seat.h"
+#include "types/display/wmclient.h"
 
 extern errno_t ds_display_create(gfx_context_t *, ds_display_flags_t,
@@ -59,8 +63,16 @@
 extern ds_client_t *ds_display_first_client(ds_display_t *);
 extern ds_client_t *ds_display_next_client(ds_client_t *);
+extern void ds_display_add_wmclient(ds_display_t *, ds_wmclient_t *);
+extern void ds_display_remove_wmclient(ds_wmclient_t *);
+extern void ds_display_add_cfgclient(ds_display_t *, ds_cfgclient_t *);
+extern void ds_display_remove_cfgclient(ds_cfgclient_t *);
+extern ds_wmclient_t *ds_display_first_wmclient(ds_display_t *);
+extern ds_wmclient_t *ds_display_next_wmclient(ds_wmclient_t *);
 extern ds_window_t *ds_display_find_window(ds_display_t *, ds_wnd_id_t);
 extern ds_window_t *ds_display_window_by_pos(ds_display_t *, gfx_coord2_t *);
+extern void ds_display_enlist_window(ds_display_t *, ds_window_t *);
 extern void ds_display_add_window(ds_display_t *, ds_window_t *);
 extern void ds_display_remove_window(ds_window_t *);
+extern void ds_display_window_to_top(ds_window_t *);
 extern ds_window_t *ds_display_first_window(ds_display_t *);
 extern ds_window_t *ds_display_last_window(ds_display_t *);
@@ -73,10 +85,19 @@
 extern ds_seat_t *ds_display_first_seat(ds_display_t *);
 extern ds_seat_t *ds_display_next_seat(ds_seat_t *);
+extern ds_seat_t *ds_display_default_seat(ds_display_t *);
+extern ds_seat_t *ds_display_find_seat(ds_display_t *, ds_seat_id_t);
+extern ds_seat_t *ds_display_seat_by_idev(ds_display_t *, ds_idev_id_t);
 extern errno_t ds_display_add_ddev(ds_display_t *, ds_ddev_t *);
 extern void ds_display_remove_ddev(ds_ddev_t *);
 extern ds_ddev_t *ds_display_first_ddev(ds_display_t *);
 extern ds_ddev_t *ds_display_next_ddev(ds_ddev_t *);
+extern void ds_display_add_idevcfg(ds_display_t *, ds_idevcfg_t *);
+extern void ds_display_remove_idevcfg(ds_idevcfg_t *);
+extern ds_idevcfg_t *ds_display_first_idevcfg(ds_display_t *);
+extern ds_idevcfg_t *ds_display_next_idevcfg(ds_idevcfg_t *);
 extern void ds_display_add_cursor(ds_display_t *, ds_cursor_t *);
 extern void ds_display_remove_cursor(ds_cursor_t *);
+extern void ds_display_update_max_rect(ds_display_t *);
+extern void ds_display_crop_max_rect(gfx_rect_t *, gfx_rect_t *);
 extern gfx_context_t *ds_display_get_gc(ds_display_t *);
 extern errno_t ds_display_paint_bg(ds_display_t *, gfx_rect_t *);
